// lscp_client.h

#ifndef __LSCP_CLIENT_H
#define __LSCP_CLIENT_H

#include "lscp_socket.h"

#if defined(__cplusplus)
extern "C" {
#endif

//-------------------------------------------------------------------------
// Client sockets.

struct _lscp_client_t;

typedef lscp_status_t (*lscp_client_proc_t)
(
    struct _lscp_client_t *pClient,
    const char *pchBuffer,
    int cchBuffer,
    void *pvData
);

typedef struct _lscp_client_t {

    lscp_client_proc_t  pfnCallback;
    void               *pvData;
    lscp_socket_agent_t tcp;
    lscp_socket_agent_t udp;

} lscp_client_t;

lscp_client_t* lscp_client_create       (char *pszHost, int iPort, lscp_client_proc_t pfnCallback, void *pvData);
lscp_status_t  lscp_client_join         (lscp_client_t *pClient);
lscp_status_t  lscp_client_destroy      (lscp_client_t *pClient);

lscp_status_t  lscp_client_call         (lscp_client_t *pClient, const char *pchBuffer, int cchBuffer, char *pchResult, int *pcchResult);

lscp_status_t  lscp_client_subscribe    (lscp_client_t *pClient);
lscp_status_t  lscp_client_unsubscribe  (lscp_client_t *pClient);

#if defined(__cplusplus)
}
#endif

#endif // __LSCP_CLIENT_H

// end of lscp_client.h
